import { ListPage } from "./list.po";
import { CalculatorPage } from "./calculator.po";
import { Navbar } from "./navbar.po";
import { browser, by, element } from "protractor";

/**
 * Calculate all modules of all examples
 */
describe("ngHyd − example sessions −", async () => {

    let listPage: ListPage;
    let calcPage: CalculatorPage;
    let navbar: Navbar;

    beforeAll(() => {
        jasmine.DEFAULT_TIMEOUT_INTERVAL = 100 * 1000;
    });

    it("calcul de tous les modules de tous les exemples −", async () => {
        listPage = new ListPage();
        calcPage = new CalculatorPage();
        navbar = new Navbar();
        listPage = new ListPage();

        // for each calculator
        let lastExampleFound = true;
        let i = 0;
        while (lastExampleFound) {
            await listPage.navigateTo();

            const examples = await element.all(by.css("#examples-list .load-example"));
            if (examples.length > i) {
                // click example #i
                await examples[i].click();
                await browser.sleep(50);

                const nbModules = await navbar.getCalculatorEntriesCount();
                for (let j = 0; j < nbModules; j++) {
                    // select module
                    await navbar.openNthCalculator(j);
                    await browser.sleep(50);
                    // calculate module
                    await calcPage.getCalculateButton().click();
                    // check results
                    const hasResults = await calcPage.hasValidResults();
                    expect(hasResults).toBe(true, `example ${i + 1}, module ${j + 1} (starting at 1)`);
                }
            } else {
                // no more examples
                lastExampleFound = false;
            }
            i++;
        }

    });

});
