import { ListPage } from "./list.po";
import { CalculatorPage } from "./calculator.po";
import { browser } from "protractor";
import { Navbar } from "./navbar.po";
import { PreferencesPage } from "./preferences.po";

/**
 * Remous
 */
describe("ngHyd − remous", () => {
    let listPage: ListPage;
    let calcPage: CalculatorPage;
    let navBar: Navbar;
    let prefPage: PreferencesPage;

    beforeEach(async () => {
        listPage = new ListPage();
        prefPage = new PreferencesPage();
        calcPage = new CalculatorPage();
        navBar = new Navbar();
        // disable evil option "empty fields on module creation"
        await prefPage.navigateTo();
        await prefPage.disableEvilEmptyFields();
        await browser.sleep(200);
    });

    it("when leaving calculated remous page then coming back to it, logs should not be duplicated", async () => {
        await navBar.clickNewCalculatorButton();

        // 1. create new Remous
        await listPage.clickMenuEntryForCalcType(4);
        await browser.sleep(300);

        // 2. calculate it, there should be 6 messages in the log
        await calcPage.getCalculateButton().click();
        expect(await calcPage.nbLogEntries()).toBe(6);
        await browser.sleep(300);

        // 3. go to home page (simplest example)
        await navBar.clickNewCalculatorButton();
        await browser.sleep(300);

        // 4. go back to Remous
        await navBar.clickCalculatorTab(0);
        await browser.sleep(300);

        // 5. there should still be 6 messages in the log
        expect(await calcPage.nbLogEntries()).toBe(6);
    });
});
